'' =================================================================================================
''
''   File....... jm_dmx_display.spin
''   Purpose.... 
''   Author..... Jon "JonnyMac" McPhalen (aka Jon Williams)
''               Copyright (c) 2010 Jon McPhalen
''               -- see below for terms of use
''   E-mail..... jon@jonmcphalen.com
''   Started.... 
''   Updated.... 
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000 

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000


con

  ' PST formatting control codes

  #1, HOME, GOTOXY, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR, #16, CLS


obj

  dmx  : "jm_dmxin"
  term : "fullduplexserial"


var


pub main | ch, row, col

  dmx.init(24, 16, 0, 0)                                        ' for JM DMX I/O board
                                          
  term.start(31, 30, %0000, 115_200)
  pause(1)
  term.tx(CLS)

  repeat
    ch := 1                                                     ' start with channel 1
    repeat row from 0 to 3
      repeat col from 0 to 7
        term.tx(GOTOXY)                                         ' position cursor
        term.tx(col * 5)
        term.tx(row)
        term.dec(dmx.read(ch++))                                ' write channel value
        term.str(string("  "))                                  ' clean-up trailing chars
      pause(1)                                                  ' prevent buffer overrun
    pause(22)                                                   ' (roughly) match dmx stream   
  
 
pub pause(ms) | t

  t := cnt - 1088                                               ' sync with system counter
  repeat (ms #> 0)
    waitcnt(t += MS_001)

                        
dat

{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}  